import * as i0 from '@angular/core';
import { Injectable, EventEmitter, Directive, Output, HostListener, Component, Inject, Input, NgModule } from '@angular/core';
import * as i2 from '@angular/common';
import { DOCUMENT, CommonModule } from '@angular/common';
import * as i1 from '@angular/cdk/drag-drop';
import { DragDropModule } from '@angular/cdk/drag-drop';

class AudioPlayerService {
    constructor() { }
}
AudioPlayerService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.12", ngImport: i0, type: AudioPlayerService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
AudioPlayerService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.12", ngImport: i0, type: AudioPlayerService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.12", ngImport: i0, type: AudioPlayerService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class ClickoutsideDirective {
    constructor(_elementRef) {
        this._elementRef = _elementRef;
        this.clickOutside = new EventEmitter();
    }
    onMouseEnter(targetElement) {
        const clickedInside = this._elementRef.nativeElement.contains(targetElement);
        if (!clickedInside) {
            this.clickOutside.emit(null);
        }
    }
}
ClickoutsideDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.12", ngImport: i0, type: ClickoutsideDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
ClickoutsideDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.12", type: ClickoutsideDirective, selector: "[clickOutside]", outputs: { clickOutside: "clickOutside" }, host: { listeners: { "document:click": "onMouseEnter($event.target)" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.12", ngImport: i0, type: ClickoutsideDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[clickOutside]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { clickOutside: [{
                type: Output,
                args: ['clickOutside']
            }], onMouseEnter: [{
                type: HostListener,
                args: ['document:click', ['$event.target']]
            }] } });

class AudioPlayerComponent {
    constructor(document, renderer) {
        this.document = document;
        this.renderer = renderer;
        this.pid = '1';
        this.color = '#44BFA3'; // default
        this.downloadURL = '';
        this.draggableClasses = [`pin`];
        this.currentlyDragged = null;
        this.options = false;
    }
    // @HostListener('window:resize') direction() {
    //   this.directionAware();
    // }
    onMouseDown($event) {
        if (!this.isDraggable($event.target))
            return false;
        this.currentlyDragged = $event.target;
        this.globalRender = this.renderer.listen('document', 'mousemove', (event) => {
            if ($event.target.id === `volume-pin${this.pid}`) {
                this.changeVolume(event);
            }
            else if ($event.target.id === `progress-pin${this.pid}`) {
                this.rewind(event);
            }
        });
        this.document.addEventListener('mouseup', () => {
            this.globalRender(); // to remove mousemove event from the dom
            this.currentlyDragged = false;
        }, false);
    }
    ngOnInit() {
        this.pid = `_pid_${this.pid}`;
    }
    ngAfterViewInit() {
        this.setAudioControls();
        // this.directionAware(); // this takes care of volume-pin bar position
        this.setControlColor();
    }
    setAudioControls() {
        this.audioPlayer = this.document.querySelector(`.green-audio-player${this.pid}`);
        this.playPause = this.audioPlayer.querySelector(`#playPause${this.pid}`);
        this.playpauseBtn = this.audioPlayer.querySelector(`.play-pause-btn${this.pid}`);
        this.loading = this.audioPlayer.querySelector(`.loading${this.pid}`);
        this.progress = this.audioPlayer.querySelector(`.progress${this.pid}`);
        this.sliders = this.audioPlayer.querySelectorAll(`.slider${this.pid}`);
        this.volumeBtn = this.audioPlayer.querySelector(`.volume-btn${this.pid}`);
        this.volumeControls = this.audioPlayer.querySelector(`.volume-controls${this.pid}`);
        this.volumeProgress = this.volumeControls.querySelector(`.slider${this.pid} .progress${this.pid}`);
        this.player = this.audioPlayer.querySelector('audio');
        this.currentTime = this.audioPlayer.querySelector(`.current-time${this.pid}`);
        this.totalTime = this.audioPlayer.querySelector(`.total-time${this.pid}`);
        this.speaker = this.audioPlayer.querySelector(`#speaker${this.pid}`);
        this.volumePin = document.getElementById(`volume-pin${this.pid}`);
    }
    setControlColor() {
        this.progress.style.backgroundColor = this.color;
        this.progress.firstChild.style.backgroundColor = this.color;
        this.volumeProgress.style.backgroundColor = this.color;
        this.volumePin.style.backgroundColor = this.color;
    }
    onLoadedmetadata() {
        this.totalTime.textContent = this.formatTime(this.player.duration);
    }
    endUp() {
        this.playPause.attributes.d.value = "M18 12L0 24V0";
        this.player.currentTime = 0;
    }
    toogleVolume(event) {
        this.volumeBtn.classList.toggle(`open`);
        this.volumeControls.classList.toggle(`hidden`);
        if (event.nodeName === 'svg') {
            event.firstChild.style.fill = this.volumeBtn.classList.contains('open') ? this.color : '';
        }
        else {
            event.style.fill = this.volumeBtn.classList.contains('open') ? this.color : '';
        }
    }
    isDraggable(el) {
        let canDrag = false;
        let classes = Array.from(el.classList);
        this.draggableClasses.forEach(draggable => {
            if (classes.indexOf(draggable) !== -1) {
                canDrag = true;
            }
        });
        return canDrag;
    }
    updateProgress() {
        var current = this.player.currentTime;
        var percent = (current / this.player.duration) * 100;
        this.progress.style.width = percent + '%';
        this.currentTime.textContent = this.formatTime(current);
    }
    updateVolume() {
        this.volumeProgress.style.height = this.player.volume * 100 + '%';
        if (this.player.volume >= 0.5) {
            this.speaker.attributes.d.value = 'M14.667 0v2.747c3.853 1.146 6.666 4.72 6.666 8.946 0 4.227-2.813 7.787-6.666 8.934v2.76C20 22.173 24 17.4 24 11.693 24 5.987 20 1.213 14.667 0zM18 11.693c0-2.36-1.333-4.386-3.333-5.373v10.707c2-.947 3.333-2.987 3.333-5.334zm-18-4v8h5.333L12 22.36V1.027L5.333 7.693H0z';
        }
        else if (this.player.volume < 0.5 && this.player.volume > 0.05) {
            this.speaker.attributes.d.value = 'M0 7.667v8h5.333L12 22.333V1L5.333 7.667M17.333 11.373C17.333 9.013 16 6.987 14 6v10.707c2-.947 3.333-2.987 3.333-5.334z';
        }
        else if (this.player.volume <= 0.05) {
            this.speaker.attributes.d.value = 'M0 7.667v8h5.333L12 22.333V1L5.333 7.667';
        }
    }
    getCoefficient(event) {
        // console.log('whole: ', event.clientX);
        const divElement = document.getElementById(`pointer${this.pid}`);
        const rectX = divElement.getBoundingClientRect();
        const offsetX = event.clientX - rectX.left;
        let slider = this.getRangeBox(event);
        let rect = slider.getBoundingClientRect();
        let K = 0;
        if (slider.dataset.direction == 'horizontal') {
            // previous approach
            // let offsetX = event.clientX - slider.offsetLeft;
            // let width = slider.clientWidth;
            // K = offsetX / width;
            // new
            K = (offsetX) / divElement.clientWidth;
        }
        else if (slider.dataset.direction == 'vertical') {
            const height = slider.clientHeight;
            const offsetY = event.clientY - rect.top;
            K = 1 - offsetY / height;
        }
        return K;
    }
    rewind(event) {
        if (this.inRange(event)) {
            this.player.currentTime = this.player.duration * this.getCoefficient(event);
        }
    }
    changeVolume(event) {
        if (this.inRange(event)) {
            this.player.volume = this.getCoefficient(event);
        }
    }
    inRange(event) {
        let rangeBox = this.getRangeBox(event);
        let rect = rangeBox.getBoundingClientRect();
        let direction = rangeBox.dataset.direction;
        if (direction == 'horizontal') {
            var min = rangeBox.offsetLeft;
            var max = min + rangeBox.offsetWidth;
            // if (event.clientX < min || event.clientX > max) return false;
        }
        else {
            var min = rect.top;
            var max = min + rangeBox.offsetHeight;
            if (event.clientY < min || event.clientY > max)
                return false;
        }
        return true;
    }
    getRangeBox(event) {
        let rangeBox = event.target;
        let el = this.currentlyDragged;
        if (event.type == 'click' && this.isDraggable(event.target)) {
            rangeBox = event.target.parentElement.parentElement;
        }
        if (event.type == 'mousemove') {
            rangeBox = el.parentElement.parentElement;
            // console.log(rangeBox)
        }
        return rangeBox;
    }
    formatTime(time) {
        const hr = Math.floor(time / 3600);
        const min = hr ? Math.floor((time - hr * 3600) / 60) : Math.floor(time / 60);
        const sec = Math.floor(time % 60);
        return (hr ? (hr + ':') : '') + (hr && min < 10 ? `0${min}` : min) + ':' + ((sec < 10) ? ('0' + sec) : sec);
    }
    togglePlay() {
        if (this.player.paused) {
            this.playPause.attributes.d.value = "M0 0h6v24H0zM12 0h6v24h-6z";
            this.player.play();
        }
        else {
            this.playPause.attributes.d.value = "M18 12L0 24V0";
            this.player.pause();
        }
    }
    makePlay() {
        this.playpauseBtn.style.display = 'block';
        this.loading.style.display = 'none';
    }
    directionAware() {
        if (window.innerHeight < 250) {
            this.volumeControls.style.bottom = '-54px';
            this.volumeControls.style.left = '54px';
        }
        else if (this.audioPlayer.offsetTop < 154) {
            this.volumeControls.style.bottom = '-164px';
            this.volumeControls.style.left = '-3px';
        }
        else {
            this.volumeControls.style.bottom = '52px';
            this.volumeControls.style.left = '-3px';
        }
    }
    toogleOptions(open) {
        if (!open) {
            setTimeout(() => {
                this.options = false;
                return;
            }, 300);
        }
        this.options = true;
    }
}
AudioPlayerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.12", ngImport: i0, type: AudioPlayerComponent, deps: [{ token: DOCUMENT }, { token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Component });
AudioPlayerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.12", type: AudioPlayerComponent, selector: "qm-audio-player", inputs: { audio: "audio", pid: "pid", color: "color", downloadURL: "downloadURL" }, host: { listeners: { "window:mousedown": "onMouseDown($event)" } }, ngImport: i0, template: "<div class=\"holder\" cdkDrag>\n    <div class=\"audio green-audio-player{{pid}} green-audio-player-scss\">\n        <div class=\"loading{{pid}}\">\n            <div class=\"spinner\"></div>\n        </div>\n        <div class=\"cdk\" cdkDragHandle>\n            <svg style=\"color: rgb(85, 87, 83);\" width=\"15\" height=\"15\" viewBox=\"0 0 15 15\" fill=\"none\"> <path fill-rule=\"evenodd\" clip-rule=\"evenodd\" d=\"M4.49999 2.5C4.49999 1.94772 4.9477 1.5 5.49999 1.5C6.05227 1.5 6.49999 1.94772 6.49999 2.5C6.49999 3.05228 6.05227 3.5 5.49999 3.5C4.9477 3.5 4.49999 3.05228 4.49999 2.5ZM8.49999 2.5C8.49999 1.94772 8.9477 1.5 9.49999 1.5C10.0523 1.5 10.5 1.94772 10.5 2.5C10.5 3.05228 10.0523 3.5 9.49999 3.5C8.9477 3.5 8.49999 3.05229 8.49999 2.5ZM4.49998 7.5C4.49998 6.94772 4.9477 6.5 5.49998 6.5C6.05227 6.5 6.49998 6.94772 6.49998 7.5C6.49998 8.05228 6.05227 8.5 5.49998 8.5C4.9477 8.5 4.49998 8.05228 4.49998 7.5ZM8.49998 7.5C8.49998 6.94771 8.9477 6.5 9.49999 6.5C10.0523 6.5 10.5 6.94772 10.5 7.5C10.5 8.05228 10.0523 8.5 9.49998 8.5C8.9477 8.5 8.49998 8.05228 8.49998 7.5ZM4.49998 12.5C4.49998 11.9477 4.9477 11.5 5.49998 11.5C6.05227 11.5 6.49998 11.9477 6.49998 12.5C6.49998 13.0523 6.05227 13.5 5.49998 13.5C4.9477 13.5 4.49998 13.0523 4.49998 12.5ZM8.49998 12.5C8.49998 11.9477 8.9477 11.5 9.49998 11.5C10.0523 11.5 10.5 11.9477 10.5 12.5C10.5 13.0523 10.0523 13.5 9.49998 13.5C8.9477 13.5 8.49998 13.0523 8.49998 12.5Z\" fill=\"#555753\"></path></svg>\n        </div>\n        <div class=\"play-pause-btn{{pid}} play-pause-btn-scss\" (click)=\"togglePlay()\">\n            <svg width=\"18\" height=\"24\" viewBox=\"0 0 18 24\">\n                <path fill=\"#566574\" fill-rule=\"evenodd\" d=\"M18 12L0 24V0\" class=\"play-pause-icon\" id=\"playPause{{pid}}\" />\n            </svg>\n        </div>\n\n        <div class=\"controls controls-scss\">\n            <span class=\"current-time{{pid}}\">0:00</span>\n            <div id=\"pointer{{pid}}\" class=\"slider{{pid}} slider-scss\" data-direction=\"horizontal\" (click)=\"rewind($event)\">\n                <div class=\"progress{{pid}} progress-scss\">\n                    <div class=\"pin\" id=\"progress-pin{{pid}}\" data-method=\"rewind\"></div>\n                    <!-- (click)=\"rewind($event)\" -->\n                </div>\n            </div>\n            <span class=\"total-time{{pid}}\">0:00</span>\n        </div>\n\n        <div class=\"volume\">\n            <div class=\"volume-btn{{pid}} volume-btn-scss\" (click)=\"toogleVolume($event.target)\">\n                <svg width=\"24\" height=\"24\" viewBox=\"0 0 24 24\">\n                    <path fill=\"#566574\" fill-rule=\"evenodd\"\n                        d=\"M14.667 0v2.747c3.853 1.146 6.666 4.72 6.666 8.946 0 4.227-2.813 7.787-6.666 8.934v2.76C20 22.173 24 17.4 24 11.693 24 5.987 20 1.213 14.667 0zM18 11.693c0-2.36-1.333-4.386-3.333-5.373v10.707c2-.947 3.333-2.987 3.333-5.334zm-18-4v8h5.333L12 22.36V1.027L5.333 7.693H0z\"\n                        id=\"speaker{{pid}}\" />\n                </svg>\n            </div>\n            <div class=\"volume-controls{{pid}} volume-controls-scss hidden\">\n                <div class=\"slider{{pid}} slider-scss\" data-direction=\"vertical\" (click)=\"changeVolume($event)\">\n                    <div class=\"progress{{pid}} progress-scss\">\n                        <div class=\"pin\" id=\"volume-pin{{pid}}\" data-method=\"changeVolume\"></div>\n                        <!-- (mousemove)=\"changeVolume($event)\" -->\n                    </div>\n                </div>\n            </div>\n        </div>\n\n        <audio preload=\"metadata\" (canplay)=\"makePlay()\" (ended)=\"endUp()\" (loadedmetadata)=\"onLoadedmetadata()\" (timeupdate)=\"updateProgress()\" (volumechange)=\"updateVolume()\">\n            <source [src]=\"audio\" type=\"audio/mpeg\">\n        </audio>\n        <div class=\"options\" *ngIf=\"downloadURL\" (clickOutside)=\"options = false\">\n            <svg (click)=\"options = !options\" class=\"opt-svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-three-dots-vertical\" viewBox=\"0 0 16 16\"> <path d=\"M9.5 13a1.5 1.5 0 1 1-3 0 1.5 1.5 0 0 1 3 0zm0-5a1.5 1.5 0 1 1-3 0 1.5 1.5 0 0 1 3 0zm0-5a1.5 1.5 0 1 1-3 0 1.5 1.5 0 0 1 3 0z\" fill=\"#888a85\"></path> </svg>\n\n            <div class=\"download{{pid}} download-scss\" *ngIf=\"options\" >\n                <a [href]=\"downloadURL\" [style.color]=\"color\" (click)=\"toogleOptions(false)\">Download</a>\n            </div>\n        </div>\n        \n    </div>\n</div>", styles: ["body{margin:0}.holder{display:flex;flex-direction:column;align-items:center}.audio.green-audio-player-scss{width:400px;min-width:300px;height:56px;box-shadow:0 4px 16px #00000012;display:flex;justify-content:space-between;align-items:center;padding-left:10px;padding-right:24px;border-radius:4px;user-select:none;-webkit-user-select:none;background-color:#fff;opacity:.8}.audio.green-audio-player-scss .play-pause-btn-scss{display:none;cursor:pointer}.audio.green-audio-player-scss .spinner{width:18px;height:18px;background-image:url(https://files.quantummethod.org.bd/media/image/static_content/spinner_loading.png);background-size:cover;background-repeat:no-repeat;animation:spin .4s linear infinite}.audio.green-audio-player-scss .slider-scss{flex-grow:1;background-color:#d8d8d8;cursor:pointer;position:relative}.audio.green-audio-player-scss .slider-scss .progress-scss{border-radius:inherit;position:absolute;pointer-events:none}.audio.green-audio-player-scss .slider-scss .progress-scss .pin{height:16px;width:16px;border-radius:8px;position:absolute;pointer-events:all;box-shadow:0 1px 1px #00000052}.audio.green-audio-player-scss .controls-scss{font-family:Roboto,sans-serif;font-size:16px;line-height:18px;color:#55606e;display:flex;flex-grow:1;justify-content:space-between;align-items:center;margin-left:24px;margin-right:24px}.audio.green-audio-player-scss .controls-scss .slider-scss{margin-left:16px;margin-right:16px;border-radius:2px;height:4px}.audio.green-audio-player-scss .controls-scss .slider-scss .progress-scss{width:0;height:100%}.audio.green-audio-player-scss .controls-scss .slider-scss .progress-scss .pin{right:-8px;top:-6px}.audio.green-audio-player-scss .controls-scss span{cursor:default}.audio.green-audio-player-scss .volume{position:relative}.audio.green-audio-player-scss .volume .volume-btn-scss{cursor:pointer}.audio.green-audio-player-scss .volume .volume-controls-scss{width:30px;height:135px;background-color:#00000070;border-radius:7px;position:absolute;left:-3px;bottom:40px;flex-direction:column;align-items:center;display:flex}.audio.green-audio-player-scss .volume .volume-controls-scss.hidden{display:none}.audio.green-audio-player-scss .volume .volume-controls-scss .slider-scss{margin-top:12px;margin-bottom:12px;width:6px;border-radius:3px}.audio.green-audio-player-scss .volume .volume-controls-scss .slider-scss .progress-scss{bottom:0;height:100%;width:6px}.audio.green-audio-player-scss .volume .volume-controls-scss .slider-scss .progress-scss .pin{left:-5px;top:-8px}svg,img{display:block}html,body{height:100%}body{display:flex;justify-content:center;align-items:center;background:#F8FFAE;background:linear-gradient(-65deg,#43C6AC,#F8FFAE);-webkit-font-smoothing:antialiased;-moz-osx-font-smoothing:grayscale}@keyframes spin{0%{transform:rotate(0)}to{transform:rotate(1turn)}}.options{margin-left:5px;margin-right:-10px;cursor:pointer;position:relative}.options .opt-svg{color:#888a85}.options .download-scss{position:absolute;padding:5px 10px;background:rgba(0,0,0,.44);border-radius:2px;box-shadow:-2px 2px 5px #0000004d;left:9px}.options .download-scss a{text-decoration:none;font-weight:700}.cdk{width:22px;cursor:move}\n"], directives: [{ type: i1.CdkDrag, selector: "[cdkDrag]", inputs: ["cdkDragData", "cdkDragLockAxis", "cdkDragRootElement", "cdkDragBoundary", "cdkDragStartDelay", "cdkDragFreeDragPosition", "cdkDragDisabled", "cdkDragConstrainPosition", "cdkDragPreviewClass", "cdkDragPreviewContainer"], outputs: ["cdkDragStarted", "cdkDragReleased", "cdkDragEnded", "cdkDragEntered", "cdkDragExited", "cdkDragDropped", "cdkDragMoved"], exportAs: ["cdkDrag"] }, { type: i1.CdkDragHandle, selector: "[cdkDragHandle]", inputs: ["cdkDragHandleDisabled"] }, { type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: ClickoutsideDirective, selector: "[clickOutside]", outputs: ["clickOutside"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.12", ngImport: i0, type: AudioPlayerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'qm-audio-player', template: "<div class=\"holder\" cdkDrag>\n    <div class=\"audio green-audio-player{{pid}} green-audio-player-scss\">\n        <div class=\"loading{{pid}}\">\n            <div class=\"spinner\"></div>\n        </div>\n        <div class=\"cdk\" cdkDragHandle>\n            <svg style=\"color: rgb(85, 87, 83);\" width=\"15\" height=\"15\" viewBox=\"0 0 15 15\" fill=\"none\"> <path fill-rule=\"evenodd\" clip-rule=\"evenodd\" d=\"M4.49999 2.5C4.49999 1.94772 4.9477 1.5 5.49999 1.5C6.05227 1.5 6.49999 1.94772 6.49999 2.5C6.49999 3.05228 6.05227 3.5 5.49999 3.5C4.9477 3.5 4.49999 3.05228 4.49999 2.5ZM8.49999 2.5C8.49999 1.94772 8.9477 1.5 9.49999 1.5C10.0523 1.5 10.5 1.94772 10.5 2.5C10.5 3.05228 10.0523 3.5 9.49999 3.5C8.9477 3.5 8.49999 3.05229 8.49999 2.5ZM4.49998 7.5C4.49998 6.94772 4.9477 6.5 5.49998 6.5C6.05227 6.5 6.49998 6.94772 6.49998 7.5C6.49998 8.05228 6.05227 8.5 5.49998 8.5C4.9477 8.5 4.49998 8.05228 4.49998 7.5ZM8.49998 7.5C8.49998 6.94771 8.9477 6.5 9.49999 6.5C10.0523 6.5 10.5 6.94772 10.5 7.5C10.5 8.05228 10.0523 8.5 9.49998 8.5C8.9477 8.5 8.49998 8.05228 8.49998 7.5ZM4.49998 12.5C4.49998 11.9477 4.9477 11.5 5.49998 11.5C6.05227 11.5 6.49998 11.9477 6.49998 12.5C6.49998 13.0523 6.05227 13.5 5.49998 13.5C4.9477 13.5 4.49998 13.0523 4.49998 12.5ZM8.49998 12.5C8.49998 11.9477 8.9477 11.5 9.49998 11.5C10.0523 11.5 10.5 11.9477 10.5 12.5C10.5 13.0523 10.0523 13.5 9.49998 13.5C8.9477 13.5 8.49998 13.0523 8.49998 12.5Z\" fill=\"#555753\"></path></svg>\n        </div>\n        <div class=\"play-pause-btn{{pid}} play-pause-btn-scss\" (click)=\"togglePlay()\">\n            <svg width=\"18\" height=\"24\" viewBox=\"0 0 18 24\">\n                <path fill=\"#566574\" fill-rule=\"evenodd\" d=\"M18 12L0 24V0\" class=\"play-pause-icon\" id=\"playPause{{pid}}\" />\n            </svg>\n        </div>\n\n        <div class=\"controls controls-scss\">\n            <span class=\"current-time{{pid}}\">0:00</span>\n            <div id=\"pointer{{pid}}\" class=\"slider{{pid}} slider-scss\" data-direction=\"horizontal\" (click)=\"rewind($event)\">\n                <div class=\"progress{{pid}} progress-scss\">\n                    <div class=\"pin\" id=\"progress-pin{{pid}}\" data-method=\"rewind\"></div>\n                    <!-- (click)=\"rewind($event)\" -->\n                </div>\n            </div>\n            <span class=\"total-time{{pid}}\">0:00</span>\n        </div>\n\n        <div class=\"volume\">\n            <div class=\"volume-btn{{pid}} volume-btn-scss\" (click)=\"toogleVolume($event.target)\">\n                <svg width=\"24\" height=\"24\" viewBox=\"0 0 24 24\">\n                    <path fill=\"#566574\" fill-rule=\"evenodd\"\n                        d=\"M14.667 0v2.747c3.853 1.146 6.666 4.72 6.666 8.946 0 4.227-2.813 7.787-6.666 8.934v2.76C20 22.173 24 17.4 24 11.693 24 5.987 20 1.213 14.667 0zM18 11.693c0-2.36-1.333-4.386-3.333-5.373v10.707c2-.947 3.333-2.987 3.333-5.334zm-18-4v8h5.333L12 22.36V1.027L5.333 7.693H0z\"\n                        id=\"speaker{{pid}}\" />\n                </svg>\n            </div>\n            <div class=\"volume-controls{{pid}} volume-controls-scss hidden\">\n                <div class=\"slider{{pid}} slider-scss\" data-direction=\"vertical\" (click)=\"changeVolume($event)\">\n                    <div class=\"progress{{pid}} progress-scss\">\n                        <div class=\"pin\" id=\"volume-pin{{pid}}\" data-method=\"changeVolume\"></div>\n                        <!-- (mousemove)=\"changeVolume($event)\" -->\n                    </div>\n                </div>\n            </div>\n        </div>\n\n        <audio preload=\"metadata\" (canplay)=\"makePlay()\" (ended)=\"endUp()\" (loadedmetadata)=\"onLoadedmetadata()\" (timeupdate)=\"updateProgress()\" (volumechange)=\"updateVolume()\">\n            <source [src]=\"audio\" type=\"audio/mpeg\">\n        </audio>\n        <div class=\"options\" *ngIf=\"downloadURL\" (clickOutside)=\"options = false\">\n            <svg (click)=\"options = !options\" class=\"opt-svg\" width=\"16\" height=\"16\" fill=\"currentColor\" class=\"bi bi-three-dots-vertical\" viewBox=\"0 0 16 16\"> <path d=\"M9.5 13a1.5 1.5 0 1 1-3 0 1.5 1.5 0 0 1 3 0zm0-5a1.5 1.5 0 1 1-3 0 1.5 1.5 0 0 1 3 0zm0-5a1.5 1.5 0 1 1-3 0 1.5 1.5 0 0 1 3 0z\" fill=\"#888a85\"></path> </svg>\n\n            <div class=\"download{{pid}} download-scss\" *ngIf=\"options\" >\n                <a [href]=\"downloadURL\" [style.color]=\"color\" (click)=\"toogleOptions(false)\">Download</a>\n            </div>\n        </div>\n        \n    </div>\n</div>", styles: ["body{margin:0}.holder{display:flex;flex-direction:column;align-items:center}.audio.green-audio-player-scss{width:400px;min-width:300px;height:56px;box-shadow:0 4px 16px #00000012;display:flex;justify-content:space-between;align-items:center;padding-left:10px;padding-right:24px;border-radius:4px;user-select:none;-webkit-user-select:none;background-color:#fff;opacity:.8}.audio.green-audio-player-scss .play-pause-btn-scss{display:none;cursor:pointer}.audio.green-audio-player-scss .spinner{width:18px;height:18px;background-image:url(https://files.quantummethod.org.bd/media/image/static_content/spinner_loading.png);background-size:cover;background-repeat:no-repeat;animation:spin .4s linear infinite}.audio.green-audio-player-scss .slider-scss{flex-grow:1;background-color:#d8d8d8;cursor:pointer;position:relative}.audio.green-audio-player-scss .slider-scss .progress-scss{border-radius:inherit;position:absolute;pointer-events:none}.audio.green-audio-player-scss .slider-scss .progress-scss .pin{height:16px;width:16px;border-radius:8px;position:absolute;pointer-events:all;box-shadow:0 1px 1px #00000052}.audio.green-audio-player-scss .controls-scss{font-family:Roboto,sans-serif;font-size:16px;line-height:18px;color:#55606e;display:flex;flex-grow:1;justify-content:space-between;align-items:center;margin-left:24px;margin-right:24px}.audio.green-audio-player-scss .controls-scss .slider-scss{margin-left:16px;margin-right:16px;border-radius:2px;height:4px}.audio.green-audio-player-scss .controls-scss .slider-scss .progress-scss{width:0;height:100%}.audio.green-audio-player-scss .controls-scss .slider-scss .progress-scss .pin{right:-8px;top:-6px}.audio.green-audio-player-scss .controls-scss span{cursor:default}.audio.green-audio-player-scss .volume{position:relative}.audio.green-audio-player-scss .volume .volume-btn-scss{cursor:pointer}.audio.green-audio-player-scss .volume .volume-controls-scss{width:30px;height:135px;background-color:#00000070;border-radius:7px;position:absolute;left:-3px;bottom:40px;flex-direction:column;align-items:center;display:flex}.audio.green-audio-player-scss .volume .volume-controls-scss.hidden{display:none}.audio.green-audio-player-scss .volume .volume-controls-scss .slider-scss{margin-top:12px;margin-bottom:12px;width:6px;border-radius:3px}.audio.green-audio-player-scss .volume .volume-controls-scss .slider-scss .progress-scss{bottom:0;height:100%;width:6px}.audio.green-audio-player-scss .volume .volume-controls-scss .slider-scss .progress-scss .pin{left:-5px;top:-8px}svg,img{display:block}html,body{height:100%}body{display:flex;justify-content:center;align-items:center;background:#F8FFAE;background:linear-gradient(-65deg,#43C6AC,#F8FFAE);-webkit-font-smoothing:antialiased;-moz-osx-font-smoothing:grayscale}@keyframes spin{0%{transform:rotate(0)}to{transform:rotate(1turn)}}.options{margin-left:5px;margin-right:-10px;cursor:pointer;position:relative}.options .opt-svg{color:#888a85}.options .download-scss{position:absolute;padding:5px 10px;background:rgba(0,0,0,.44);border-radius:2px;box-shadow:-2px 2px 5px #0000004d;left:9px}.options .download-scss a{text-decoration:none;font-weight:700}.cdk{width:22px;cursor:move}\n"] }]
        }], ctorParameters: function () {
        return [{ type: Document, decorators: [{
                        type: Inject,
                        args: [DOCUMENT]
                    }] }, { type: i0.Renderer2 }];
    }, propDecorators: { audio: [{
                type: Input
            }], pid: [{
                type: Input
            }], color: [{
                type: Input
            }], downloadURL: [{
                type: Input
            }], onMouseDown: [{
                type: HostListener,
                args: ['window:mousedown', ['$event']]
            }] } });

class AudioPlayerModule {
}
AudioPlayerModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.12", ngImport: i0, type: AudioPlayerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
AudioPlayerModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.12", ngImport: i0, type: AudioPlayerModule, declarations: [AudioPlayerComponent,
        ClickoutsideDirective], imports: [DragDropModule,
        CommonModule], exports: [AudioPlayerComponent] });
AudioPlayerModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.12", ngImport: i0, type: AudioPlayerModule, imports: [[
            DragDropModule,
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.12", ngImport: i0, type: AudioPlayerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        AudioPlayerComponent,
                        ClickoutsideDirective
                    ],
                    imports: [
                        DragDropModule,
                        CommonModule
                    ],
                    exports: [
                        AudioPlayerComponent
                    ]
                }]
        }] });

/*
 * Public API Surface of audio-player
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AudioPlayerComponent, AudioPlayerModule, AudioPlayerService };
//# sourceMappingURL=qm-audio-player.mjs.map
